#include <stdio.h>	
#include <windows.h>
#include "Serial.h"
#include <GL/glut.h> 
const int COMxx = 62;
unsigned int R,G,B;
char title[] = "Color sensing";
int refreshPeriod = 10; 

void SERIAL (int serial_port, int baud_rate, int samples, 
			 int sampling_interval, int bytes_perFrame) {
 char Data[]= {"@"}, receive_buf[4096], ToF_buf[10], strColour[8];
 int Data_length=sizeof(Data)/sizeof(char), rcvBytes, rcvString, i,j,k;
  if (SERIAL_Open(serial_port, baud_rate)) exit(0);
   i=rcvString=0;
   do {
	   rcvBytes = SERIAL_Read(receive_buf, 1);
	   ToF_buf[i]=receive_buf[0];
	   Sleep(10);
	   rcvString += rcvBytes;
	   if (rcvBytes!=0) i++;
   }while (ToF_buf[i-1] != 0x0A);
   ToF_buf[i]='\0';	//printf(" ToF_buf=%s     \r",ToF_buf);
   i=j=k=0;
   while( ToF_buf[j] != ('\n') ) {  
    do{
	   strColour[i++] = ToF_buf[j++];
    } while ( (ToF_buf[j] != ',') & (ToF_buf[j] != '\r') );
    strColour[i]=0;
	if(k==0) B = atoi(strColour);
    if(k==1) R = atoi(strColour);
	if(k==2) G = atoi(strColour);
    i=0;
    j++;
	k++;
   }  
  printf ("R:%d, G:%d, B:%d          \r",R, G, B); 
  SERIAL_Close();
}

void display() {
 int P_samples = 100, ODR=250 , frame_bytes=32;
   SERIAL (COMxx, 9600, P_samples, ODR, frame_bytes);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glTranslatef(0.0, 0.0, -20.0);
   if ( (R>10+G) && (R>10+B) ) glColor3f(1.0, 0.0, 0.0);
   else if ( (G>10+R) && (G>10+B) ) glColor3f(0.0, 1.0, 0.0);
   else if ( (B>10+R) && (B>10+G) ) glColor3f(0.0, 0.0, 1.0);
   else glColor3f(1.0, 1.0, 1.0);
   glBegin(GL_POLYGON);
    glVertex3f(2.0, 4.0, 0.0);
    glVertex3f(8.0, 4.0, 0.0);
    glVertex3f(8.0, 6.0, 0.0);
    glVertex3f(2.0, 6.0, 0.0);
   glEnd();
   glutSwapBuffers();  //double buffering
}
 
void timer(int value) {
   glutPostRedisplay();
   glutTimerFunc(refreshPeriod, timer, 0); 
}
 
void reshape(GLsizei width, GLsizei height) {	
   GLfloat aspect = (GLfloat)width / (GLfloat)height;
   glViewport(0, 0, width, height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(45.0f, aspect, 0.1f, 100.0f);
}

int main(int argc, char** argv) {
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE);
   glutInitWindowSize(640, 480);   		
   glutInitWindowPosition(50, 50); 		
   glutCreateWindow(title);          	
   glutDisplayFunc(display);       		
   glutReshapeFunc(reshape);       		                    		
   glutTimerFunc(0, timer, 0);
   glutMainLoop();
 return(0);
}